/*********************************************************
 * ShootEmUp    whmp 2015 11 16 
 *
 * an example for MRETV
 *
 * This was written durring the early development of MRETV. 
 * It only compiles for the 328 based Arduinos.
 * 
 * ATTACH A KEYBOARD DIRCTLY TO MRETV/Arduino TO PLAY
 *
 * A classic style game using cell animation techniques.
 * Just a few basic parts are implemented but enough to show there is plenty of CPU power
 * left while generating video and sound. Many objects of different types are animated, colision detection
 * is done and user input handled.
 *
 * The virtual graphics operations processor (GOP) is used in a simple but useful manor.
 * The graphics operations list (GOPL) is fairly simple and a good example to read to see what the GOP is about.
 * An associated function adds an extra twist to the GOPL and  although not necessary here the function
 * is made to easily port to new sketches.
 *
 * The actual game code was a learning experience for me so will not be much of one for you, sorry.
 *
 *  About Extension defines.
 *
 * Defining these in the MRETV library folder allows for extra optimisation and
 * improved performance. All examples are predefined in Arduino\libraries\MRETV\MRETVextensions.h
 * 
 * for MasteRasterExtendedTransmissionVision 2
 **********************************************************/

#include <MrETV.h>
#ifndef ShootEmUp // make sure the extensions are set correctly
//#error Please define ShootEmUp in arduino\libraries\MRETV\MRETVextensions.h , See comments at start of sketch
#endif
/* **************  the extensions for this sketch
 #define firmwaremultiport
 #define mergstreams
 #define dualaudio
 #define translatekeys
 #define fontheight 8
 #define fakejoy2
 #define graphicsengine
 #define countframes
 ************************* */

#ifdef __AVR_ATmega168__
#error ShootEmUp is not compatable with ATmega168, sorry
#endif

#include "saw.h"
 PROGMEM const unsigned char * const sounds [] PROGMEM= 	{
  silent,
  //sawCo,sawDbo,sawDo,sawEbo,sawEo,sawFo,sawGbo,sawGo,sawAbo,sawAo,sawBbo,sawBo,
  //sawCo1,sawDbo1,sawDo1,sawEbo1,sawEo1,sawFo1,sawGbo1,sawGo1,sawAbo1,sawAo1,sawBbo1,sawBo1,
  //sawCo2,sawDbo2,sawDo2,sawEbo2,sawEo2,sawFo2,sawGbo2,sawGo2,sawAbo2,sawAo2,sawBbo2,sawBo2,
  //sawCo3,sawDbo3,sawDo3,sawEbo3,sawEo3,sawFo3,sawGbo3,sawGo3,sawAbo3,sawAo3,sawBbo3,sawBo3,
  //sawCo4,sawDbo4,sawDo4,sawEbo4,sawEo4,sawFo4,sawGbo4,sawGo4,sawAbo4,sawAo4,sawBbo4,sawBo4,
  sawCo5,sawDbo5,sawDo5,sawEbo5,sawEo5,sawFo5,sawGbo5,sawGo5,sawAbo5,sawAo5,sawBbo5,sawBo5,
  sawCo6,sawDbo6,sawDo6,sawEbo6,sawEo6,sawFo6,sawGbo6,sawGo6,sawAbo6,sawAo6,sawBbo6,sawBo6,
  sawCo7,sawDbo7,sawDo7,sawEbo7,sawEo7,sawFo7,sawGbo7,sawGo7,sawAbo7,sawAo7,sawBbo7,sawBo7
};
#include "shootemupfont.h"
uchar  Screenbuf[(27*46)]; // character based data

// Helper graphics operation list and associated function. Used to makes the first line a larger character size.
// It can do any line. Useful for highlighting or menu functions. In the long run the GOPL is a powerful 16 bytes.
volatile uchar bigline[]=
{
  95,flag_gopcharwidth|flag_gopscreenwidth|flag_gopcharheight,1,22, 2,//100
  111,flag_gopcharwidth|flag_gopindex |flag_gopscreenwidth|flag_gopcharheight,0,5,5,15, 1,
  255,flag_gopreset ,gop_int(bigline)
  };

  volatile unsigned char * setbigline(uint textbase, uchar linelen, uchar selline){
    while( Video.LineCount> Video.ScreenBottom); // these should be sure to keep changes off screen
    while( Video.LineCount< Video.ScreenBottom); // get rid of them if you need speed

    bigline[0]= Video.ScreenTop+(selline*8)-1; // target line
    //bigline[1]=flag_gopcharwidth|flag_gopscreenwidth|flag_gopcharheight;
    //bigline[2]=1; //double wide char
    bigline[3]=(linelen+( Video.ScreenCenter/8)<22)?linelen:22-( Video.ScreenCenter/8);
    //bigline[4]=2; // double tall chars


    bigline[5]= Video.ScreenTop+(selline*8)+15; // end of target line
    // bigline[6]=flag_gopcharwidth|flag_gopindex |flag_gopscreenwidth|flag_gopcharheight;
    // bigline[7]=0; //single wide
    bigline[8]=(textbase+((selline+1)*linelen))&0xff; // skipped half a line so fix pointer
    bigline[9]=(textbase+((selline+1)*linelen))>>8;
    bigline[10]=linelen;
    ///bigline[11]=1; //single tall chars

    //bigline[12]=5;//+256 =line261 good time to reset list
    //bigline[13]=flag_gopreset;
    //bigline[14]=(uchar)((int)bigline&0xff); // start of list
    //bigline[15]=(uchar)((int)bigline>>8);
    return(bigline);
  }

// The rest of the code is quick and dirty.
// It works but thats about it.

#define gunchar 128
#define amochar 16
#define enemychar 0
#define updwnchar 16
#define siscrw 44

int score=0;
uchar skill,level;
char dwn,dwn2,dwn3,dwn4,up,upcol,up2,upcol2;
char g,g2,g3,g4;
char dirgun;
char  rowdir[8];
char  rowrow[8];
char  amokey[4];
char  amocol[4];

void getdown(){  // drop by 2 lines
  uchar a,b,c;
  c=0;
  for (a=0;a<8;a++) {
    rowrow[a]++;
    for (b=0;b<siscrw;b++){
      if(Screen.get(rowrow[a]-1,b)<16)Screen.write(rowrow[a],b,Screen.get(rowrow[a]-1,b));
      if(level<4)      Screen.write(rowrow[a]-1,b,32);
    }
  }
  for (a=0;a<8;a++) {
    rowrow[a]++;
    for (b=0;b<siscrw;b++){
      if(Screen.get(rowrow[a]-1,b)<16)Screen.write(rowrow[a],b,Screen.get(rowrow[a]-1,b));
      if(level<4)      Screen.write(rowrow[a]-1,b,32);
    }
  }
  for (b=0;b<siscrw;b++)if(Screen.get(rowrow[7],b)<16)c=1;
  if(!c) for (a=0;a<8;a++)   rowrow[a]-=2; // bottom line all dead
}

void newlevel(){
  int a,c;
  while(Video.read()!=' '){
    while(Video.LineCount!=Video.ScreenBottom);
    for (a=0;a<8;a++) rowdir[a]=animaterow(rowrow[a],rowdir[a],enemychar);
  }
  for(a=0;a<8;a++){
    rowdir[a]=a&1;
    rowrow[a]=(a*2)+2;
  }
  dwn=0;
  dwn2= 0;
  dwn3=0;
  dwn4=0;
  up=99;
  upcol=1;
  up2=99;
  upcol2=1;
  g=0;
  g2=0;
  g3=0;
  g4=0;
  dirgun=1;
  Screen.fill(32);
  for(c=2;c<17;c+=2)
    for(a=10+c;a<36;a+=2){
      Video.MasterRaster[a+(c*siscrw)+1]=8;
    }
  Video.MasterRaster[23+(25*siscrw)+1]=8+gunchar;
  Video.MasterRaster[13]=8+gunchar;
  Video.MasterRaster[15]=8+gunchar;
  Video.MasterRaster[17]=8+gunchar;
  Video.MasterRaster[19]=8+gunchar;
  Video.MasterRaster[1]=8;
  skill=127;
}

void setup(){
}

void loop() {
  int a,chin;
  level=0;
  Video.keyrate(0x14);
  Screen.begin(shootemupfont,Screenbuf,27*fontheight,siscrw,8,12,1);
  setbigline((uint)Screenbuf,siscrw,0);
  setgoplist(bigline);
  Screen.fill(32);
  Screen_progstr(0,6,"Shoot Em Up");
  Screen.write(9,22,'A');
  Screen_progstr(11,4,"MasterRasterExtendedTransmissionVision");
  Screen_progstr(13,19,"Example");
  Screen_progstr(20,9,"right or left cursor to move");
  Screen_progstr(22,9,"down cursor or shift to fire");
  Screen_progstr(24,10,"space to start or continue");
  Screen.write(16,17,8);
  for(a=0;a<8;a++){
    rowdir[a]=a&1;
    rowrow[a]=(a*2)+2;
  }
  newlevel();
  while(1){
    chin=Video.read();
    switch(chin){
    case 0x0d:
      return;
    case '>':
    case '.':
      level++;
      break;
    case '<':
    case ',':
      level--;
      break;
    case '-':
    case '_':
      skill=(skill<<1)+1;
      skill=(skill<<1)+1;
      break;
    case '+':
    case '=':
      skill=(skill>>1);
      break;
    }

    if(skill)    while(Video.LineCount!=Video.ScreenBottom);
    for (a=0;a<8;a++) rowdir[a]=animaterow(rowrow[a],rowdir[a],enemychar);
    if(fjright)animaterow(25,0,gunchar);
    else {
      if(fjleft)animaterow(25,1,gunchar);
      else animaterow(25,0,230); // nothin near 230 I hope ...
    }
    if(up==99){
      if(fjbutton||fjdown){
        for(a=0;a<(siscrw-1);a++)if(Video.MasterRaster[a+(25*siscrw)]!=32){
          upcol=a+1;
          break;
        }
        if(Screen.get(24,upcol)==32) {
          up=animateupdwn(upcol,up,0); // don't shoot own bullit
          setaudior(7,15);
        }
      }
    }
    else   if(up2==99){
      if(fjbutton||fjdown){
        for(a=0;a<(siscrw-1);a++)if(Video.MasterRaster[a+(25*siscrw)]!=32){
          upcol2=a+1;
          break;
        }
        if(Screen.get(24,upcol2)==32) {
          setaudior(7,15);
          up2=animateupdwn(upcol2,up2,0);
        }
      }
    }
    if(!(Video.FrameCount&skill)) {
      if(dwn==0){
        for(a=0;a<(siscrw);a++)if(Video.MasterRaster[a+(25*siscrw)]!=32){
          g=a;
          for(a=23;a>1;a--)if(Screen.get(a,g)<16){
            dwn=(a*4)+4;
            setaudio(14,15);
            break;
          }
          break;
        }
      }
      else    if(dwn2==0){
        for(a=0;a<(siscrw);a++)if(Video.MasterRaster[a+(25*siscrw)]!=32){
          g2=a;
          for(a=23;a>1;a--)if(Screen.get(a,g2)<16){
            dwn2=(a*4)+4;
            setaudio(14,15);
            break;
          }
          break;
        }
      }
      else    if(dwn3==0){
        for(a=0;a<(siscrw);a++)if(Video.MasterRaster[a+(25*siscrw)]!=32){
          g3=a;
          for(a=23;a>1;a--)if(Screen.get(a,g3)<16){
            dwn3=(a*4)+4;
            setaudio(14,15);
            break;
          }
          break;
        }
      }
      else    if(dwn4==0){
        for(a=0;a<(siscrw);a++)if(Video.MasterRaster[a+(25*siscrw)]!=32){
          g4=a;
          for(a=23;a>1;a--)if(Screen.get(a,g4)<16){
            dwn4=(a*4)+4;
            setaudio(14,15);
            break;
          }
          break;
        }
      }
    }
    if(dwn)  dwn=animateupdwn(g,dwn,1);
    if(level)    if(dwn2)   dwn2=animateupdwn(g2,dwn2,1);
    if(level>1)     if(dwn3)   dwn3=animateupdwn(g3,dwn3,1);
    if(level>2)     if(dwn4)   dwn4=animateupdwn(g4,dwn4,1);
    if(up!=99)   up=animateupdwn(upcol,up,0);
    if(up2!=99)   up2=animateupdwn(upcol2,up2,0);
  }
}

char animateupdwn(char col, char key,char dir)// key is current height.
{
  uint row,rc;
  uchar c;
  row=key/4;
  c=key&3; //1/4 row
  rc=(row*siscrw)+col;  // screen pos
  // clear from screen
  if(Video.MasterRaster[rc]==(c+amochar))Video.MasterRaster[rc]=32;
  if(c==3)if(Video.MasterRaster[rc+siscrw]==(4+amochar))Video.MasterRaster[rc+siscrw]=32;
  //inc/dec
  if(dir)key++;
  else key--;
  if(key==0)return(99);
  else if(key==100)return(0);
  // recalc
  row=key/4;
  c=key&3;
  rc=(row*siscrw)+col;
  // place new
  if(Video.MasterRaster[rc]==32){
    if(key!=99)Video.MasterRaster[rc]=c+amochar;
    if(c==3){
      if(Video.MasterRaster[rc+siscrw]==32){
        Video.MasterRaster[rc+siscrw]=4+amochar;
      }
      else{
        Video.MasterRaster[rc]=32;
        if(dir)  ahit(rc+siscrw,gunchar);
        else ahit(rc+siscrw,enemychar);
        if(dir)key=0;
        else key=99;
      }
    }
  }
  else{
    if(dir)  ahit(rc,gunchar);
    else ahit(rc,enemychar);
    if(dir)key=0;
    else key=99;
  }
  return(key);
}

char animaterow(char row,char dir,uchar basechar ){
  int a,b;
  uchar c;
  b=row*siscrw;
  if((Video.MasterRaster[b]<basechar+16)&&(Video.MasterRaster[b]>basechar-1))dir=0;
  if((Video.MasterRaster[b+(siscrw-1)]<basechar+16)&&(Video.MasterRaster[b+(siscrw-1)]>basechar-1))dir=1;
  if(dir){
    for(a=b;a<b+siscrw;a++){
      c=Video.MasterRaster[a];
      if((c>32)&&(c<'Z'))Video.MasterRaster[a]--;
      if((c<(basechar+15))&&(c>(basechar))){
        Video.MasterRaster[a]++;
        if(Video.MasterRaster[a]==9+basechar)  Video.MasterRaster[a-1]=1+basechar;
      }// if
      else{
        if(c==(15+basechar)) Video.MasterRaster[a]=32;
      }//else
    }  //for row
  } //if dir
  else {
    for(a=b+(siscrw-1);a>=b;a--){
      c=Video.MasterRaster[a];
      if((c>32)&&(c<'Z'))Video.MasterRaster[a]--;
      if( (c<(basechar+16))&&(c>basechar+1)){
        Video.MasterRaster[a]--;
        if(Video.MasterRaster[a]==7+basechar)Video.MasterRaster[a+1]=(15+basechar);
      }// if
      else{
        if(c==basechar+1) Video.MasterRaster[a]=32;
      }//else
    }  //for row
  }//elsenot dir
  return(dir);
}

void ahit(int loc,char basechar)
{
  char hit;
  hit=Video.MasterRaster[loc];
  if((hit>basechar)&&(hit<basechar+16)){
    if(hit>(8+basechar)){
      loc=loc-1;
      hit=Video.MasterRaster[loc];
    }
    if(hit<(4+basechar)){
      Video.MasterRaster[loc+1]='X';
      Video.MasterRaster[loc]=32;
    }
    else{
      if(hit!=(8+basechar)) Video.MasterRaster[loc+1]=32;
      Video.MasterRaster[loc]='Y';
    }
    if(basechar==enemychar){
      setaudio(2,15);
      score=score+1;
      Screen.udec(0,0,(score+(level*100))*10);
      if(!(score&7)){
        skill>>=1;
        if(rowrow[7]==24)goto loose;
        getdown();
      }
      if(score==68){
        level++;
        Screen_progstr(0,5,"Level Up");
        newlevel();
        score=0;
      }
    }
    else {
      setaudior(40,30);
      Video.MasterRaster[23+(25*siscrw)+1]=8+gunchar;
      if( Video.MasterRaster[13]==8+gunchar)Video.MasterRaster[13]=32;
      else if(Video.MasterRaster[15]==8+gunchar)Video.MasterRaster[15]=32;
      else if (Video.MasterRaster[17]==8+gunchar)Video.MasterRaster[17]=32;
      else if (Video.MasterRaster[19]==8+gunchar)Video.MasterRaster[19]=32;
      else{
loose:
        for(hit=1;hit<26;hit+=2)   Screen_progstr(hit,(hit-1)/2,"Byte The Dust Space Cadet !");
        newlevel();
      }
    }
  }

}
void showscore()
{
  uchar l,h;
  l=score;
  h=Video.FrameHigh;
  h=0;
  while(l>99){
    l-=100;
    h++;
  }
  Screen.write(0,0,'0'+h);
  h=0;
  while(l>9){
    l-=10;
    h++;
  }
  Screen.write(0,1,'0'+h);
  Screen.write(0,2,'0'+l);
  Screen.write(0,3,'0');
  Screen.write(0,4,'0');
}


