//1. parts
 //  in  'Arduino\libraries\MRETV\MRETV.extensions'  we will 
 // '#define monoaudio' 
 //'#define firmwaremultiport // keyboard and serial
 // #define translatekeys     // no rawkey up/down stuff
 // #define mergstreams       // handle both together

 #include <MRETV.h>   // MRETV itself
 #include <textfont.h>   // a font,  default fontheight  is 8
 #include "saw.h"      // some sound samples
 PROGMEM const unsigned char * const sounds [] PROGMEM = { // optional array of sound samples, must be called 'sounds[]' and in progmem.
   sawCo4,sawDbo4,sawDo4,sawEbo4,sawEo4,sawFo4,sawGbo4,sawGo4,sawAbo4,sawAo4,sawBbo4,sawBo4};
 uchar  Screenbuf [20 * 20]={
   " Use a string here  to set your initial display"};   // some place to put display data, 20 rows of 20 characters

 // 2. begin
 void setup(){  
   Screen.begin(textfont,Screenbuf, 20*fontheight,20,20,20,1);  // start video output, sound,  keyboard and serial extensions
   // (font, buffer, ScreenHeight (pix), ScreenWidth (chars), top (pix), left (pix), mode)  top and left are centering, mode=1 for normal text
 }

 volatile uint a,depth=0,Speed=56;
 void loop(){
   uchar chin; //character in from serial/keyboard stream
   for(a=4000;a;a--);// slow us down

   //3. update incomming information
   switch(chin=Video.readS()){ // a character from serial (with keyboard merged)
   case 0: // no character received from input
     break;
   case 's':  // s from input
     setaudio(0,35);
     break;
   case 0x0d: // <return> from input
     depth=0xfff8&(depth+0x8);
     depth-=1;
     break;
   }

   //3. update screen
   if(chin){
     Screen_progstr(8,0,"Speed "); // update information as needed
     Screen.dec(Speed-((int)depth/3));
     Screen_progstr(11,0,"Depth ");
     Screen.hexint(depth++);

 //3. update sound
     if (!(depth&0x07)) switch(depth/0x8){  // beep now and then
     case 1:
       ssample(sawBo4,50);  // play a sample directly  (sample, duration (1/60sec) )
       break;
     case 17:
       depth=0;
       break;
     default:
       if( (depth/0x8)>5)setaudio((depth/0x8)-6,15); // play a sample from the array  (sample, duration (1/60sec) )
       break;
     }
   }
 }
