/*********************************************************
 * SimpleDisplay    whmp 2015 11 16
 *
 * an example for MRETV
 *
 * basic input and output
 * input from serial port is put on screen
 * if a space or a 1 is found a comment is printed.
 * 
 * use a terminal program like 'Putty' to connect - 2400 8 n 1
 * or
 *  try this from a cmd prompt
 * mode com3:2400,n,8,1
 * copy con com3:
 * ...now hit enter, type some stuff hit enter again.
 * ... or try this
 * mode com3:2400,n,8,1
 * dir > com3:
 * ... or try this
 * mode com3:2400,n,8,1
 * copy filepath com3:
 *
 * About Extension defines.
 *
 * Defining these in the MRETV library folder allows for extra optimisation and
 * improved performance. All examples are predefined in Arduino\libraries\MRETV\MRETVextensions.h
 *
 * for MasteRasterExtendedTransmissionVision 2
 **********************************************************/


#include <MrETV.h>
#ifndef default_extensions // make sure the extensions are set correctly
//#error Please define 'default_extensions' in arduino\libraries\MRETV\MRETVextensions.h , See comments at start of sketch
#endif

#include "textfont.h"  // plain but readable font

uchar asciibuf[23*38]; //  chars to display .

void setup(){
  Screen.begin(textfont,asciibuf, 23*8,38,22,52,1); 
  // Screen.begin not Video.Begin adds another layer to allow easy text display
}

void loop() {
  uchar chin;
  int count=0;
  Screen.fill(' '); // clear screen
  Screenprogstr("MasterRasterExtendedTransmissionVision"); // print a message
  Screenprogstr("Connect with a Serial monitor or term "); // print a message
  Screenprogstr("program at 2400 baud 8n1              ");
  Screenprogstr("use the 'any' key or a 1 or a space...");
  while(1)
    if((chin=Video.readS())){  // read user input readS() is serial port read
      Screen.write(chin);  // put input on screen 
      count++;         // count input
      if(chin=='1')Screenprogstr(" You hit an 1 ");
      if(chin=='#'){
        Screenprogstr(" You have hit ");
        Screen.dec(count);
        Screenprogstr(" keys ");
      }
    }
}



